#define _WIN32_WINNT  0x0600
//#define  WINVER       0x0501
#define _WIN32_IE     0x0600

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>

#ifndef TTI_NONE
// ToolTip Icons (Set with TTM_SETTITLE)
#define TTI_NONE                0
#define TTI_INFO                1
#define TTI_WARNING             2
#define TTI_ERROR               3
#if (_WIN32_WINNT >= 0x0600)
#define TTI_INFO_LARGE          4
#define TTI_WARNING_LARGE       5
#define TTI_ERROR_LARGE         6
#endif  // (_WIN32_WINNT >= 0x0600)
#endif

#include "win090.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */


    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 090",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           250,                 /* Ancho */
           90,                 /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    InitCommonControls();
    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }
    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static HINSTANCE hInstance;
    static HFONT hFont;
    UDACCEL uda[] = {
        {0, 1},
        {5, 10},
        {10, 50},
        {15, 100}
    };
    NM_UPDOWN *nmup;
    LPNMHDR pnmhdr;

    switch (msg)              /* manipulador del mensaje */
    {
        case WM_CREATE:
            hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
            hFont = CreateFont(-30, 0, 0, 450, 300, FALSE, FALSE, FALSE,
                DEFAULT_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
                PROOF_QUALITY, DEFAULT_PITCH | FF_ROMAN, "Times New Roman");
            CreateWindowEx(0, "EDIT", "100", ES_RIGHT | ES_NUMBER | WS_VISIBLE | WS_CHILD | WS_BORDER,
                10, 10, 80, 22, hwnd,(HMENU)ID_EDIT, hInstance, NULL);
            CreateWindowEx(0, UPDOWN_CLASS, NULL,
                WS_CHILD | WS_VISIBLE | UDS_ALIGNRIGHT | UDS_WRAP | UDS_SETBUDDYINT | UDS_AUTOBUDDY,
                0, 0,
                0, 0,
                hwnd, (HMENU)ID_UPDOWN,
                hInstance, NULL);
            SendDlgItemMessage(hwnd, ID_UPDOWN, UDM_SETRANGE, 0, (LPARAM) MAKELONG((short) 100, (short) -100));
            SendDlgItemMessage(hwnd, ID_UPDOWN, UDM_SETACCEL, (WPARAM)sizeof(uda)/sizeof(UDACCEL), (LPARAM)uda);
            SendDlgItemMessage(hwnd, ID_UPDOWN, UDM_SETBASE, 10, 0);
            return 0;
        case WM_NOTIFY:
            pnmhdr = (LPNMHDR)lParam;
            switch(pnmhdr->code) {
                case UDN_DELTAPOS:
                    if(pnmhdr->idFrom == ID_UPDOWN) {
                        nmup = (NM_UPDOWN*)lParam;
                        if(!((nmup->iPos+nmup->iDelta) % 3)) {
                            if(nmup->iDelta > 0) {
                                nmup->iDelta++;
                            } else {
                                nmup->iDelta--;
                            }
                        }
                        return FALSE;
                    }
                    break;
            }
            break;
        case WM_DESTROY:
           DeleteObject(hFont);
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}
